<template>
  <CModal
    :show.sync="visible"
    :centered="false"
    :close-on-backdrop="false"
    class="item-modal modal-xxl"
    @open="$emit('open')"
    @close="$emit('close')"
  >
    <template #header>
      <h6 class="modal-title">
        <font-awesome-icon :icon="['fas', 'wine-bottle']" />
        オークションお申込み
      </h6>
      <CButtonClose @click="onCancel" />
    </template>

    <div
      v-loading="loading"
      class="box-inner-form"
    >
      <div class="row">
        <div class="col-12 col-lg-6">
          <div class="box-slider">
            <hooper
              v-if="model.images.length"
              ref="itemSlider"
              :settings="itemSliderSettings"
              class="slide-list"
              @slide="updateItemSlider"
            >
              <slide
                v-for="item in model.images"
                :key="item.id"
              >
                <div class="img" :style="{ backgroundImage: `url(${item.path})` }" />
              </slide>

              <hooper-navigation slot="hooper-addons" />
              <hooper-pagination slot="hooper-addons" mode="fraction" />
            </hooper>

            <div v-if="model.images.length" class="thumbnail-list">
              <ul>
                <li
                  v-for="(item, index) in model.images"
                  :key="item.id"
                  :class="`${currentSlide === index ? 'active' : ''} `"
                  @click="$refs.itemSlider.slideTo(index)"
                >
                  <div class="img" :style="{ backgroundImage: `url(${item.path})` }" />
                </li>
              </ul>
            </div>
          </div>

          <table class="table table-hover">
            <thead>
              <th colspan="3">
                落札
              </th>
            </thead>
            <tbody>
              <tr>
                <td>箱番 / 行</td>
                <td>{{ model.box.name }}</td>
                <td>{{ model.number }}</td>
              </tr>
              <tr>
                <td>品名</td>
                <td colspan="2">
                  {{ model.name }}
                </td>
              </tr>
              <tr>
                <td>備考</td>
                <td colspan="2">
                  {{ model.note }}
                </td>
              </tr>
            </tbody>
          </table>
        </div>

        <div class="col-12 col-lg-6">
          <div role="group" class="form-group form-row">
            <label sm="3" class="col-form-label col-sm-4">
              入札数
            </label>
            <div class="col-sm-8">
              <span class="h3 mb-0">{{ model.bids.length }}</span>
            </div>
          </div>

          <div role="group" class="form-group form-row form-status">
            <label sm="3" class="col-form-label col-sm-4">
              入札締切
            </label>
            <div class="col-sm-8">
              <div class="h3">
                <div
                  v-if="expireDate"
                  :class="`${
                    $moment(expireDate).isAfter($moment()) ?
                      'badge badge-success' :
                      'badge badge-danger'
                  }`"
                >
                  {{
                    $moment(expireDate).isAfter($moment()) ?
                      $moment(expireDate).format('DD/MM/YYYY HH:mm:ss') :
                      $text.info('CLOSED_BID')
                  }}
                </div>
              </div>
            </div>
          </div>

          <div role="group" class="form-group form-row">
            <label sm="3" class="col-form-label col-sm-4">
              最高入札者
            </label>
            <div class="col-sm-8">
              <!-- TODO Replace mock data -->
              <span class="h3 mb-0">
                898
                <span class="badge badge-success">TOP</span>
              </span>
            </div>
          </div>

          <div role="group" class="form-group form-row">
            <label sm="3" class="col-form-label col-sm-4">
              現在最高額
            </label>
            <div class="col-sm-6">
              <span class="h3 mb-0">&yen; {{ model.current_price }}</span>
            </div>
            <div class="col-sm-2 text-right">
              <CButton
                color="light"
                @click="getItemDetail()"
              >
                <font-awesome-icon :icon="['fas', 'sync']" />
                更新
              </CButton>
            </div>
          </div>

          <div role="group" class="form-group form-row">
            <label sm="3" class="col-form-label col-sm-4">
              あなたの入札金額
            </label>
            <div class="col-sm-8">
              <span class="h3 mb-0">&yen; {{ yourPrice }}</span>
            </div>
          </div>

          <div role="group" class="form-group form-row">
            <label sm="3" class="col-form-label col-sm-4">
              投入金額
            </label>
            <div class="col-sm-8">
              <CInput
                v-model="currentPrice"
                type="text"
                size="lg"
              >
                <template #prepend>
                  <div class="h3 mb-0 pt-2">
                    &yen; &nbsp;
                  </div>
                </template>
                <template #append>
                  <CButton
                    color="success"
                    @click="bidItem()"
                  >
                    入札
                  </CButton>
                  <CButton
                    color="light"
                    @click="currentPrice = ''"
                  >
                    クリア
                  </CButton>
                </template>
              </CInput>
            </div>
          </div>

          <div role="group" class="form-group form-row">
            <label sm="3" class="col-form-label col-12">
              メモ
            </label>
            <div class="col-12">
              <CTextarea
                v-model="memo"
                rows="5"
              />
            </div>
          </div>

          <div role="group" class="form-group form-row">
            <div class="col-12">
              <CButton
                color="dark"
                variant="outline"
                @click="setMemo()"
              >
                <font-awesome-icon :icon="['fas', 'save']" class="width-1x" />
                書き込み
              </CButton>
              <CButton
                variant="outline"
                color="dark"
                @click="memo = ''"
              >
                <font-awesome-icon :icon="['fas', 'eraser']" class="width-1x" />
                クリア
              </CButton>
            </div>
          </div>
        </div>
      </div>
    </div>

    <template #footer>
      <div class="row">
        <div class="col-6 offset-3 text-center">
          <CButton :disabled="!model.prev_id || loading" @click="gotoPrevItem()">
            <font-awesome-icon :icon="['fas', 'arrow-left']" class="width-1x" />
            前へ
          </CButton>

          <CButton :disabled="!model.next_id || loading" @click="gotoNextItem()">
            次へ
            <font-awesome-icon :icon="['fas', 'arrow-right']" class="width-1x" />
          </CButton>
        </div>

        <div class="col-3 text-right">
          <CButton
            variant="outline"
            color="dark"
            @click="onCancel"
          >
            クリア
          </CButton>
        </div>
      </div>
    </template>
  </CModal>
</template>

<style lang="scss" scoped>
  .item-modal {
    /deep/ {
      .box-slider {
        margin-bottom: 15px;
      }

      .hooper {
        height: auto;
        outline: 0;
        &-list {
          padding-bottom: 30px;
        }
        &-next,
        &-prev {
          transform: translateY(-78%);
          outline: 0;
        }
      }

      .slide-list {
        .img {
          display: block;
          background-repeat: no-repeat;
          background-position: center center;
          background-size: contain;
          padding-bottom: 75%;
        }
      }

      .thumbnail-list {
        ul {
          li {
            display: inline-block;
            vertical-align: middle;
            position: relative;
            cursor: pointer;
            margin-right: 4px;
            margin-bottom: 4px;
            &.active {
              &:before {
                opacity: 0;
              }
              img {
                border: 0;
              }
            }
            &:before {
              opacity: 1;
              display: block;
              content: '';
              position: absolute;
              top: 0;
              left: 0;
              width: 100%;
              height: 100%;
              background: rgba(#000, 0.5);
              transition: all 0.4s ease;
            }
            .img {
              display: block;
              background-repeat: no-repeat;
              background-position: center top;
              background-size: contain;
              width: 40px;
              height: 40px;
              border: 1px solid #ccc;
              transition: all 0.4s ease;
            }
          }
        }
      }

      .input-group-lg {
        .form-control {
          color: $text-color;
          font-weight: bold;
          font-size: 1.53125rem;
        }
      }
      .form-status {
        .badge {
          width: 100%;
        }
      }

      .modal-footer {
        display: block;
      }
    }
  }
</style>

<script>
import 'hooper/dist/hooper.css'

import { get } from 'lodash'
import {
  Hooper,
  Slide,
  Navigation as HooperNavigation,
  Pagination as HooperPagination
} from 'hooper'

import common from '~/mixins/common'
import Item from '~/models/Item'

export default {
  components: {
    Hooper,
    Slide,
    HooperNavigation,
    HooperPagination
  },

  mixins: [
    common
  ],

  props: {
    /**
     * Item id
     */
    id: {
      type: Number,
      default: 0
    },

    /**
     * List of id
     */
    idList: {
      type: Array,
      default: () => []
    }
  },

  data () {
    return {
      visible: false,
      loading: false,
      currentPrice: 0,
      currentId: 0,
      memo: '',
      model: new Item(),

      // Slider options
      itemSliderSettings: {
        autoPlay: false,
        transition: 300,
        wheelControl: false
      },
      currentSlide: 0
    }
  },

  computed: {
    /**
     * Your current price
     */
    yourPrice () {
      if (!this.model.bids.length) {
        return 0
      }
      const priceList = this.model.bids.map(item => item.price)
      priceList.sort((a, b) => b - a)
      return priceList[0]
    },

    /**
     * Deadline
     */
    expireDate () {
      const deadline = get(this, 'model.box.deadline', null)

      return deadline || ''
    }
  },

  watch: {
    // Parent ID
    id (val) {
      this.currentId = val
      this.getItemDetail()
    }
  },

  methods: {
    /**
     * Open dialog
     */
    open () {
      this.visible = true
    },

    /**
     * When you click Cancel button
     */
    onCancel () {
      this.visible = false
    },

    /**
     * When you click Cancel button
     *
     * @param {Object} payload - Slide info
     */
    updateItemSlider (payload) {
      if (payload) {
        this.currentSlide = payload.currentSlide
      }
    },

    /**
     * Get detail item
     */
    getItemDetail () {
      this.loading = true
      this.$dam.getItemDetail({ id: this.currentId })
        .then((res) => {
          this.model = new Item(res.data)
          this.currentPrice = this.model.current_price
          this.memo = get(this, 'model.memos[0].content', '')
          this.loading = false
        })
        .catch((err) => {
          this.showError(err)
          this.loading = false
        })
    },

    /**
     * Set memo for item
     */
    async setMemo () {
      this.loading = true
      try {
        await this.$dam.setMemo({ product_id: this.currentId, content: this.memo })

        this.$toast.success(
          this.$text.info('UPDATED')
        )
      } catch (err) {
        this.showError(err)
      }
      this.loading = false
    },

    /**
     * Bid an item
     */
    async bidItem () {
      this.loading = true
      try {
        await this.$dam.setBid({ product_id: this.currentId, price: this.currentPrice })

        this.$toast.success(
          this.$text.info('UPDATED')
        )
      } catch (err) {
        this.showError(err)
      }
      this.loading = false
    },

    /**
     * Go to prev item
     */
    gotoPrevItem () {
      if (this.model.prev_id) {
        this.currentId = this.model.prev_id
        this.getItemDetail()
      }
    },

    /**
     * Go to next item
     */
    gotoNextItem () {
      if (this.model.next_id) {
        this.currentId = this.model.next_id
        this.getItemDetail()
      }
    }
  }
}
</script>
